diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/mksyscomp v15.6301-amd64/pop/src/mksyscomp
--- v15.63/pop/src/mksyscomp	2008-11-06 04:28:40.000000000 -0500
+++ v15.6301-amd64/pop/src/mksyscomp	2009-12-24 13:00:41.000000000 -0500
@@ -1,5 +1,5 @@
 #!/bin/sh
-# --- Copyright University of Sussex 2008. All rights reserved. ----------
+# --- Copyright University of Sussex 1993. All rights reserved. ----------
 # File:             C.unix/src/mksyscomp
 # Purpose:          Build saved images for POPC, POPLINK and POPLIBR
 # Author:           John Gibson, Jun 24 1988 (see revisions)
@@ -36,7 +36,6 @@
 done
 
 # --- Revision History ---------------------------------------------------
-# --- Aaron Sloman, Nov  6 2008 Changed corepop11 to corepop
 # --- John Gibson, Jul 10 1993  Image now built in popsys on corepop11
 # --- Robert John Duncan, Jan  9 1992
 #		Rewritten to allow multiple arguments and always to use safepop11
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/newpop v15.6301-amd64/pop/src/newpop
--- v15.63/pop/src/newpop	1993-07-09 23:55:48.000000000 -0400
+++ v15.6301-amd64/pop/src/newpop	2008-06-13 05:30:10.000000000 -0400
@@ -15,9 +15,13 @@
 
 # Run the NEWPOP saved image based on corepop
 if [ $# -eq 0 ]; then
-	corepop +$popsys/newpop.psv
+#	echo corepop +$popsys/newpop.psv
+        corepop +$popsys/newpop.psv
+#        gdb /home/hebisch/poplog/v15.61-amd64/pop/pop/corepop
 else
-	corepop +$popsys/newpop.psv "$@"
+#	echo corepop +$popsys/newpop.psv "$@"
+        corepop +$popsys/newpop.psv "$@"
+#        gdb /home/hebisch/poplog/v15.61-amd64/pop/pop/corepop
 fi
 
 # --- Revision History ---------------------------------------------------
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/pdr_compose.p v15.6301-amd64/pop/src/pdr_compose.p
--- v15.63/pop/src/pdr_compose.p	1990-06-26 14:30:44.000000000 -0400
+++ v15.6301-amd64/pop/src/pdr_compose.p	2005-03-11 05:30:39.000000000 -0500
@@ -13,7 +13,8 @@
 ;;; Macros for dropping code at -_drop_ptr-
 
 lconstant macro (
-	LONG	= [_drop_ptr!(l)++ -> _drop_ptr],
+        QUAD    = [_drop_ptr!(l)++ -> _drop_ptr],
+	LONG	= [_drop_ptr!(i)++ -> _drop_ptr],
 	SHORT	= [_drop_ptr!(s)++ -> _drop_ptr],
 	BYTE	= [_drop_ptr!(b)++ -> _drop_ptr],
 );
@@ -27,7 +28,7 @@
 	lvars _drop_ptr, _comp, _size;
 
 	;;; Determine size of procedure
-	##(w)[_21 | b.r] -> _size;				;;; code size in words
+	##(w)[_26 | b.r] -> _size;				;;; code size in words
 	@@PD_COMPOSITE_TABLE[_size] _sub @@POPBASE -> _size;	;;; plus header
 
 	;;; Allocate new procedure record
@@ -45,32 +46,37 @@
 	_comp@PD_COMPOSITE_TABLE ->> _drop_ptr -> _comp!PD_EXECUTE;
 
 	;;; Set up the stack frame
-	;;; movl %eax, %PB
-	_16:C589 -> SHORT;									;;; 2 bytes
-	;;; pushl %PB
-	_16:55 -> BYTE;										;;; 1 byte
+	;;; movq %rax, %PB
+        _16:48 -> BYTE,
+	_16:C589 -> SHORT;	;;; 3 bytes
+        ;;; pushq %PB
+	_16:55 -> BYTE;		;;; 1 byte
 
 	;;; Call PD_COMPOSITE_P1 and PD_COMPOSITE_P2
 	;;; (assuming that @@PD_EXECUTE == 0)
-	;;; movl [@@PD_COMPOSITE_P1](%PB), %eax
-	_16:458B -> SHORT, @@PD_COMPOSITE_P1 -> BYTE;		;;; 3 bytes
-	;;; call *(%eax)
-	_16:10FF -> SHORT;									;;; 2 bytes
-	;;; movl [@@PD_COMPOSITE_P2](%PB), %eax
-	_16:458B -> SHORT, @@PD_COMPOSITE_P2 -> BYTE;		;;; 3 bytes
-	;;; call *(%eax)
+	;;; movq [@@PD_COMPOSITE_P1](%PB), %rax
+        _16:48 -> BYTE,
+	_16:458B -> SHORT, @@PD_COMPOSITE_P1 -> BYTE;		;;; 4 bytes
+	;;; call *(%rax)
+	_16:10FF -> SHORT;		;;; 2 bytes
+	;;; movq [@@PD_COMPOSITE_P2](%PB), %rax
+        _16:48 -> BYTE,
+	_16:458B -> SHORT, @@PD_COMPOSITE_P2 -> BYTE;		;;; 4 bytes
+	;;; call *(%rax)
 	_16:10FF -> SHORT;									;;; 2 bytes
 
 	;;; Save pointer to exit code
 	_drop_ptr -> _comp!PD_EXIT;
 
 	;;; Unwind the stack frame
-	;;; addl $4, %esp
-	_16:C483 -> SHORT, _4 -> BYTE;						;;; 3 bytes
-	;;; movl 4(%esp), %PB
-	_16:6C8B -> SHORT, _16:24 -> BYTE, _4 -> BYTE;		;;; 4 bytes
+	;;; addq $8, %rsp
+        _16:48 -> BYTE,
+	_16:C483 -> SHORT, _8 -> BYTE;		;;; 4 bytes
+	;;; movq 8(%rsp), %PB
+        _16:48 -> BYTE,
+	_16:6C8B -> SHORT, _16:24 -> BYTE, _8 -> BYTE;		;;; 5 bytes
 	;;; ret
-	_16:C3 -> BYTE;										;;; 1 bytes
+	_16:C3 -> BYTE;		;;; 1 bytes
 enddefine;
 
 endsection;		/* $-Sys */
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/setpop.p v15.6301-amd64/pop/src/setpop.p
--- v15.63/pop/src/setpop.p	2000-01-06 06:58:07.000000000 -0500
+++ v15.6301-amd64/pop/src/setpop.p	2009-12-27 11:03:55.000000000 -0500
@@ -43,6 +43,7 @@
 		Vms_jpi_string, Vms_jpi_int, Vms_get_image_name,
 		Io$-Cons_device, Io$-Get_char, Io$-Rms_parse, Io$-Rms_search,
 		Io$-Cons_stddev, Explode_substring,
+                dummy_procedure_callback_helper,
 		),
 		image_version
 	;
@@ -73,7 +74,8 @@
 				poppid, popusername, popdirectory, popheader,
 				pop_runtime, pop_runtime_actions,
 				pop_first_setpop, pop_nobanner, pop_noinit, popunderx,
-				setpop
+				setpop,
+              dummy_procedure_callback_helper
 			;
 
 constant
@@ -892,6 +894,7 @@
 enddefine;		/* Setup_system */
 
 define lvars Setpop_setup_system();
+        Get_mem_break() -> _user_base;
 	chain(_nextframe(_caller_sp_flush()), _0, Setup_system)
 enddefine;
 
@@ -923,6 +926,11 @@
 	sysexit()
 enddefine;
 
+define dummy_procedure_callback_helper();
+   lvars _dummy1 = 666, _dummy2 = 42;
+   _extern printf('%d, %d\n', _dummy1, _dummy2);
+enddefine;
+
 endsection;		/* $-Sys */
 
 
Only in v15.63/pop/src: setpop.p.2000
Only in v15.63/pop/src: shortvec.p
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/sig_async.p v15.6301-amd64/pop/src/sig_async.p
--- v15.63/pop/src/sig_async.p	1992-06-17 12:50:50.000000000 -0400
+++ v15.6301-amd64/pop/src/sig_async.p	2005-03-13 04:56:40.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 1992. All rights reserved. ----------
+/* --- Copyright University of Sussex 2005. All rights reserved. ----------
  > File:            C.all/src/sig_async.p
  > Purpose:			routines to control asynchronous interrupts
  > Author:          Roger Evans, Apr 18 1988 (see revisions)
@@ -9,6 +9,7 @@
 #_INCLUDE 'declare.ph';
 #_INCLUDE 'signals.ph';
 
+lconstant _WORD_RANGE_MASK = _int(2**(WORD_BITS-1)-1);
 
 	;;; controlling asynchronous interrupts
 define active pop_enable_interrupts;
@@ -29,7 +30,9 @@
 define sys_send_signal(pid, signum);
 	lvars pid, signum;
 	Sys$-Check_integer(signum, 0);
-	_nonneg(_extern kill(Sys$-Pint_->_sint(pid, _-1), _int(signum)))
+;;;	(_extern kill(Sys$-Pint_->_sint(pid, _-1), _int(signum)))
+	(_extern kill(Sys$-Pint_->_sint(pid, _WORD_RANGE_MASK), _int(signum)))
+            _lteq _2147483647
 enddefine;
 
 #_ENDIF
@@ -37,6 +40,8 @@
 
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Mar 13 2005
+		Patch provided by Waldek Hebisch for AMD64 Poplog
 --- John Gibson, Jun 17 1992
 		Changed sys_send_signal to allow any signed (big)integer value for pid
 --- John Gibson, Jun 27 1988
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/sr_sys.p v15.6301-amd64/pop/src/sr_sys.p
--- v15.63/pop/src/sr_sys.p	1998-06-02 09:57:10.000000000 -0400
+++ v15.6301-amd64/pop/src/sr_sys.p	2005-03-11 05:30:39.000000000 -0500
@@ -316,7 +316,7 @@
 										endif _biset _MAP_FIXED,
 					_sr_channel, _fileoffs) -> _res;
 
-	if _neg(_res) then
+	if _res _eq _-1 /* _gr _2147483647 */ then
 		Syserr_mishap(_sr_device, 1, 'ERROR MAPPING SAVED IMAGE')
 	elseif _res /== _baddr then
 		mishap(_sr_device, 1, 'ERROR MAPPING SAVED IMAGE (mapped at wrong address)')
@@ -570,13 +570,13 @@
 				_extern shmget(_shmem_key, ##(b){_size|w}, _0) -> _res;
 				if isinstalled == undef then
 					;;; first try for shared memory, set isinstalled
-					_nonneg(_res) -> isinstalled
-				elseif _neg(_res) then
+					_res _lteq _2147483647 -> isinstalled
+				elseif _res _gr _2147483647 then
 					;;; previous sect was shared mem but not this one!
 					Syserr_mishap(0, 'ERROR MAPPING INSTALLED SAVED IMAGE')
 				endif
 			endif;
-			if _nonneg(_res) then
+			if (_res) _lteq _2147483647 then
 				;;; _res is a shared memory identifier - now attach to it
 				lvars _baddr = _base@(w->b);
 				if _extern shmat(_res, _baddr, _SHM_RDONLY) /== _baddr then
@@ -1272,8 +1272,8 @@
 		Read(_shrsp, @@(struct SHR_SECT)++);	;;; file offset and offs length
 		;;; deleting existing shared memory segments
 		_extern shmget(_shmem_key, ##(b){_shrsp!SHRS_SIZE | w}, _0) -> _shmid;
-		if _neg(_shmid)
-		or _neg(_extern shmctl(_shmid, _IPC_RMID, _0)) then
+		if (_shmid) _gr _2147483647
+		or (_extern shmctl(_shmid, _IPC_RMID, _0)) _gr _2147483647 then
 			Warning(file, 'CAN\'T DE-INSTALL SAVED IMAGE');
 			return
 		endif;
@@ -1303,7 +1303,7 @@
 		;;; create new shared memory segment from this area
 		;;; (644 mode is read/write by owner and read by all)
 		_extern shmget(_shmem_key, _blen, _IPC_CREAT _biset _8:644) -> _shmid;
-		if _neg(_shmid)
+		if (_shmid) _gr _2147483647
 		or (_extern shmat(_shmid, _0, _0) ->> _baddr) == _-1
 		or _extern[NI] read(_sr_channel, _baddr, _blen) /== _blen
 		then
Only in v15.63/pop/src: sr_sys.p.1998
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/sys_file_move.p v15.6301-amd64/pop/src/sys_file_move.p
--- v15.63/pop/src/sys_file_move.p	1997-03-08 10:24:40.000000000 -0500
+++ v15.6301-amd64/pop/src/sys_file_move.p	2005-03-11 05:30:39.000000000 -0500
@@ -35,13 +35,23 @@
 	define lconstant unlink(f);
 		lvars f;
 		lstackmem stackbuff _fnbuf;
-		_extern unlink(Encode_sys(f,_fnbuf))
+                lvars _pop_res =
+		_extern unlink(Encode_sys(f,_fnbuf));
+                if _pop_res _lteq _2147483647 then _pop_res
+                else
+                   _pop_res _sub _4294967296
+                endif
 	enddefine;
 
 	define lconstant link(f, t, _fnbuf);
 		lvars f, t, _fnbuf;
 		lstackmem stackbuff _tnbuf;
-		_extern link(Encode_sys(f,_fnbuf), Encode_sys(t,_tnbuf))
+                lvars _pop_res =
+		_extern link(Encode_sys(f,_fnbuf), Encode_sys(t,_tnbuf));
+                if _pop_res _lteq _2147483647 then _pop_res
+                else
+                   _pop_res _sub _4294967296
+                endif
 	enddefine;
 
 	define lconstant Rename(f, t);
@@ -51,7 +61,12 @@
 		define lconstant rename(f, t, _fnbuf);
 			lvars f, t, _fnbuf;
 			lstackmem stackbuff _tnbuf;
-			_extern rename(Encode_sys(f,_fnbuf), Encode_sys(t,_tnbuf))
+                        lvars _pop_res =
+			_extern rename(Encode_sys(f,_fnbuf), Encode_sys(t,_tnbuf));
+                    if _pop_res _lteq _2147483647 then _pop_res
+                    else
+                       _pop_res _sub _4294967296
+                    endif
 		enddefine;
 
 		while _neg(rename(f, t, _nbuf2) ->> _res)
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/sys_file_stat.p v15.6301-amd64/pop/src/sys_file_stat.p
--- v15.63/pop/src/sys_file_stat.p	1999-03-19 20:00:10.000000000 -0500
+++ v15.6301-amd64/pop/src/sys_file_stat.p	2009-12-24 15:34:16.000000000 -0500
@@ -47,12 +47,13 @@
 			Encode_sys(file, _nbuf)
 		endif -> _arg;
 		_extern[INDIR] _routine(_arg, _stbuf) -> _res;
-		quitunless(_neg(_res) and _ERRNO == _:EINTR);
+		quitunless(_res _gr _2147483647 and _ERRNO == _:EINTR);
 		_CHECKINTERRUPT
 	endrepeat;
-	returnif(_neg(_res)) (false -> statbuff);
+	returnif((_res) _gr _2147483647) (false -> statbuff);
 
 	datalength(statbuff) -> len;
+;;;        printf(len, 'statbuff len: %p\n');
 	returnif(len == 0);
 
 	go_on len to ONE TWO THREE FOUR FIVE SIX SEVEN EIGHT NINE else TEN;
@@ -86,19 +87,24 @@
 
 FOUR:
 	;;; user id
-	_pint(_stbuf!ST_UID)			-> fast_subscrv(4,statbuff);
+;;;	_pint(_stbuf!ST_UID)			-> fast_subscrv(4,statbuff);
+	Sint_->_pint(_stbuf!ST_UID)			-> fast_subscrv(4,statbuff);
 
 THREE:
 	;;; group id
-	_pint(_stbuf!ST_GID)			-> fast_subscrv(3,statbuff);
+;;;	_pint(_stbuf!ST_GID)			-> fast_subscrv(3,statbuff);
+	Sint_->_pint(_stbuf!ST_GID)			-> fast_subscrv(3,statbuff);
 
 TWO:
 	;;; last modified time
-	Sint_->_pint(_stbuf!ST_MTIME)	-> fast_subscrv(2,statbuff);
-
+;;;	Sint_->_pint(_stbuf!ST_MTIME)	-> fast_subscrv(2,statbuff);
+        _pint(_stbuf!ST_MTIME)   -> fast_subscrv(2,statbuff);
+;;;        printf(_pint(_stbuf!ST_MTIME), '_pint(_stbuf!ST_MTIME) = %p\n');
+;;;        printf(fast_subscrv(2,statbuff), 'fast_subscrv(2,statbuff) = %p\n');
 ONE:
 	;;; file size
 	_pint(_stbuf!ST_SIZE)			-> fast_subscrv(1,statbuff);
+;;;        printf(statbuff, 'statbuff = %p\n');
 enddefine;
 
 endsection;		/* $-Sys */
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/sys_host_name.p v15.6301-amd64/pop/src/sys_host_name.p
--- v15.63/pop/src/sys_host_name.p	1997-03-10 09:07:49.000000000 -0500
+++ v15.6301-amd64/pop/src/sys_host_name.p	2005-03-11 05:30:39.000000000 -0500
@@ -22,7 +22,7 @@
 	lvars _offs;
 	lstackmem stackbuff _obuf;
 	lconstant _size = _:SIZEOF(stackbuff);
-	if _nonneg(_extern gethostname(_obuf, _size)) then
+	if (_extern gethostname(_obuf, _size)) _lteq _2147483647 then
 		if (_locc(_obuf, @@(b)[_size], _0) ->> _offs) == _-1 then
 			@@(b)[_size] -> _offs
 		endif;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/sys_input_waiting.p v15.6301-amd64/pop/src/sys_input_waiting.p
--- v15.63/pop/src/sys_input_waiting.p	1997-02-18 10:39:18.000000000 -0500
+++ v15.6301-amd64/pop/src/sys_input_waiting.p	2005-03-11 05:30:39.000000000 -0500
@@ -102,7 +102,7 @@
 	repeat
 		if wait and testdef $-Sys$-Xt$-Xpt_IO_wait
 		and (weakref $-Sys$-Xt$-Xpt_IO_wait(_fdsets) ->> _nfds) then
-			quitunless(_neg(_int(_nfds) ->> _nfds))
+			quitunless((_int(_nfds) ->> _nfds) _gr _2147483647)
 		else
 			lvars _n, _rdarg, _wrarg, _exarg;
 			if _nonzero(_fdsets@WFDS_RD_SET!FDS_NFDS ->> _nfds) then
@@ -125,7 +125,7 @@
 
 			_extern select(_nfds, _rdarg, _wrarg, _exarg,
 							if wait then _NULL else _tvp0 endif) -> _nfds;
-			quitunless(_neg(_nfds) and _ERRNO == _:EINTR)
+			quitunless((_nfds) _gr _2147483647 and _ERRNO == _:EINTR)
 		endif;
 
 		_CHECKINTERRUPT;
@@ -201,10 +201,13 @@
 	FD_ZERO(_fds);
 	FD_SET(_fd, _fds);
 	_0 ->> _tvp0!TIM_SEC -> _tvp0!TIM_USEC;
-	if _extern[NI] select(_fd _add _1, _fds, _NULL, _NULL, _tvp0) _sgr _0 then
+        lvars _selres 
+           = _extern[NI] select(_fd _add _1, _fds, _NULL, _NULL, _tvp0);
+	if _selres _sgr 0 and _selres _lteq _2147483648  then
 		;;; return a true result if select says input waiting, but try
 		;;; to make it the number of chars
-		if _nonneg(_extern[NI] ioctl(_fd, _FIONREAD, _ip)) then
+		if (_extern[NI] ioctl(_fd, _FIONREAD, _ip)) 
+                      _lteq _2147483647 then
 			_pint(_ip!(int))
 		else
 			0
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/sys_io_control.p v15.6301-amd64/pop/src/sys_io_control.p
--- v15.63/pop/src/sys_io_control.p	1994-07-08 12:23:40.000000000 -0400
+++ v15.6301-amd64/pop/src/sys_io_control.p	2005-03-11 05:30:39.000000000 -0500
@@ -25,7 +25,8 @@
 
 define sys_io_control(dev, _mode) -> _res;
 	lvars dev, devparams = false, argstruct = false, _mode, _res, _argbptr;
-
+;;; _extern printf('sys_io_control\n') -> _;
+;;; _extern fflush(_0) -> _;
 	unless isdevice(dev) then
 		;;; structure argument supplied
 		((), dev, _mode) -> (dev, _mode, argstruct);
@@ -50,7 +51,8 @@
 		endif;
 	endif;
 
-	_nonneg(_extern[NI] ioctl(dev!D_FILE_DESC, _mode, _argbptr)) -> _res;
+	(_extern[NI] ioctl(dev!D_FILE_DESC, _mode, _argbptr))
+          _lteq _2147483647 -> _res;
 
 	if devparams and _res then
 		Get_tty_params(dev, devparams);
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/sys_real_time.p v15.6301-amd64/pop/src/sys_real_time.p
--- v15.63/pop/src/sys_real_time.p	1995-06-30 12:19:46.000000000 -0400
+++ v15.6301-amd64/pop/src/sys_real_time.p	2009-12-29 23:55:34.000000000 -0500
@@ -14,7 +14,7 @@
 
 ;;; -------------------------------------------------------------------
 
-section $-Sys => sys_real_time;
+section $-Sys => sys_real_time, sys_microtime;
 
 	/*	Time in seconds since midnight 1 Jan 1970 GMT
 	*/
@@ -28,6 +28,16 @@
 #_ENDIF
 enddefine;
 
+define sys_microtime();
+#_IF DEFV BERKELEY >= 4.2
+    lstackmem struct TIMEVAL _tvp;
+    _extern gettimeofday(_tvp, _NULL) -> ;
+    Sint_->_pint(_tvp!TIM_SEC)*1000000 + Sint_->_pint(_tvp!TIM_USEC)
+#_ELSE
+    Sint_->_pint(_extern time(_NULL))*1000000
+#_ENDIF
+enddefine;
+
 endsection;
 
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syscomp/asmout.p v15.6301-amd64/pop/src/syscomp/asmout.p
--- v15.63/pop/src/syscomp/asmout.p	1999-02-26 09:03:21.000000000 -0500
+++ v15.6301-amd64/pop/src/syscomp/asmout.p	2005-03-11 05:30:39.000000000 -0500
@@ -47,14 +47,18 @@
 
 define nextlab();
 	dlocal pop_pr_radix = 36;
-	'.L' >< nextlabel;
+	'_L' >< nextlabel;
 	nextlabel fi_+ 1 -> nextlabel;
 enddefine;
 
 ;;; Global labels constructed from word plus prefix char
 
 define lconstant asm_label(word, prefix_char);
+#_IF false
 	lconstant SEP_CHAR = `.`;
+#_ELSE
+        lconstant SEP_CHAR = `_`;
+#_ENDIF
 	lvars n, len, string, q, r, prefix_char, word;
 	if isstring(word) then word else fast_word_string(word) endif -> string;
 	datalength(string) -> len;
@@ -72,8 +76,9 @@
 				a a a a a a a a a a a a a a a a		;;;   a    --   p
 				a a a a a a a a a a s s s s c c		;;;   q    -- \(128)
 			else c;
-
-			A: a: d: u :		;;; alpha, digit, underscore
+                        u:          ;;; underscore
+                              `_` ;   ;;;      
+			A: a: d: 		;;; alpha, digit, underscore
 				nextloop;
 
 			$ :
@@ -82,7 +87,7 @@
 				then
 					;;; replace section separator $- with SEP_CHAR
 					-> ;			;;; erase $
-					unless n == 1 then SEP_CHAR endunless;
+					unless n == 1 then `_`, `S`  endunless;
 					n fi_+ 1 -> n;	;;; skip -
 					nextloop
 				;;; else drop thru to "s"
@@ -91,6 +96,7 @@
 			s: c:				;;; other sign, control etc
 				;;; represent as 3 decimal digits
 				() fi_// 100 -> q -> r;
+                                `_` ;
 				q fi_+ `0`;
 				r fi_// 10 -> q -> r;
 				q fi_+ `0`, r fi_+ `0`;
@@ -127,7 +133,8 @@
 	$- ASM_BYTE_STR	= '\t.byte\t',
 	$- ASM_SHORT_STR= '\t.value\t',
 	$- ASM_INT_STR	= '\t.long\t',
-	$- ASM_WORD_STR	= ASM_INT_STR,
+        $- ASM_DOUBLE_STR  = '\t.quad\t',
+	$- ASM_WORD_STR	= ASM_DOUBLE_STR,
 );
 
 ;;;	Starting and ending an assembly code file
@@ -156,14 +163,21 @@
 
 global constant procedure (
 	asm_align_word =
+             #_IF true
+                        outcode(% '.align\t8' %)           
+             #_ELSE    
 		#_IF DEF LINUX and not(DEF LINUX_ELF)
 			outcode(% '.align\t2' %)
 		#_ELSE
 			outcode(% '.align\t4' %)
-		#_ENDIF,
-
-	asm_align_double = identfn,
-
+                #_ENDIF
+             #_ENDIF,
+asm_align_double = 
+#_IF false
+       identfn
+#_ELSE
+       outcode(% '.align\t8' %)
+#_ENDIF,
 	;;; asm_align_file -- end-of-file alignment
 	;;; (don't define if not needed)
 	;;; asm_align_file = identfn,
@@ -212,11 +226,12 @@
 	asm_outshort	= outdatum(% ASM_SHORT_STR %),
 	asm_outint		= outdatum(% ASM_INT_STR %),
 	asm_outword		= outdatum(% ASM_WORD_STR %),
+        asm_outdouble = outdatum(% ASM_DOUBLE_STR %), 
 );
 
 define asm_out_dfloat(hipart, lopart);
 	lvars hipart, lopart;
-	asm_outword(lopart, hipart, 2);
+	asm_outint(lopart, hipart, 2);
 enddefine;
 
 	/*	-asm_addbits- is used to accumulate a sequence of bitfields into
@@ -292,7 +307,7 @@
 #_IF DEF SOLARIS
 		explode(' \\/ 4'),
 #_ELSE
-		explode(' >> 2'),
+		explode(' >> 3'),
 #_ENDIF
 		explode(ASM_RPAR), explode(' + '),
 		dest_characters(hdr_size)
@@ -309,17 +324,17 @@
 	;;; Push nfroz frozvals (last nfroz longwords planted)
 	;;; EBX is the user stack pointer
 	asm_outlab(nextlab() ->> l);
-	fast_for offs from nfroz*4 by -4 to 4 do
-		asmf_pr('\tsubl\t$4, %ebx\n');
-		asmf_printf(asm_expr(l, "-", offs), '\tmovl\t%p, %%eax\n');
-		asmf_pr('\tmovl\t%eax, (%ebx)\n');
+	fast_for offs from nfroz*8 by -8 to 8 do
+		asmf_pr('\tsubq\t$8, %rbx\n');
+		asmf_printf(asm_expr(l, "-", offs), '\tmovq\t%p, %%rax\n');
+		asmf_pr('\tmovq\t%rax, (%rbx)\n');
 	endfast_for;
 	;;; Jump to -jmplab-
-	asmf_printf(jmplab, '\tmovl\t$%p, %%eax\n');
-	asmf_pr('\tjmp\t*%eax\n');
+	asmf_printf(jmplab, '\tmovq\t$%p, %%rax\n');
+	asmf_pr('\tjmp\t*%rax\n');
 	;;; Return the number of longwords planted
 	asm_align_word();
-	(nfroz*11+10)>>2;
+	(nfroz*18+15)>>3;
 enddefine;
 
 
@@ -333,14 +348,14 @@
 define asm_gen_exfunc_clos_code(action_lab);
 	lvars action_lab;
 	;;; leal _exfunc_clos_action, %eax (= 6 bytes)
-	asmf_printf(action_lab, '\tleal\t%p, %%eax\n');
+	asmf_printf(action_lab, '\tleaq\t%p, %%r10\n');
 	;;; call *%eax (= 2 bytes)
-	asmf_printf('\tcall\t*%%eax\n');
+	asmf_printf('\tcall\t*%%r10\n');
 	;;; pad to 16 bytes
-#_IF DEF SYSTEM_V
+#_IF DEF SYSTEM_V or DEF LINUX
 	asmf_printf('\t.align\t8\n');
 #_ELSE
-	asmf_printf('\t.space\t8\n');
+	asmf_printf('\t.space\t5\n');
 #_ENDIF
 enddefine;
 
@@ -366,7 +381,7 @@
 
 	;;; Use C compiler to link
 constant
-	cc_link_command_header = '$POP__cc -Wl,-x,-export-dynamic -o $IM \\\n'
+	cc_link_command_header = '$POP__cc -Wl,-export-dynamic -o $IM \\\n'
 ;
 
 #_ELSE
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syscomp/genfloat.p v15.6301-amd64/pop/src/syscomp/genfloat.p
--- v15.63/pop/src/syscomp/genfloat.p	1995-05-11 09:41:16.000000000 -0400
+++ v15.6301-amd64/pop/src/syscomp/genfloat.p	2005-03-11 05:30:39.000000000 -0500
@@ -68,7 +68,7 @@
 	lvars signif, expo;
 #_IF WORD_BITS==DOUBLE_BITS
 	lvars (hi32, lo32) = d_float_ints(signif, expo);
-	(hi32 << 32) || lo32 &&~~ 2:111;
+	(hi32 << 32) || lo32 &&~~ 2:11;
 #_ELSE
 	syspop\:_pint(s_float_val(signif, expo)) &&~~ 2:11;
 #_ENDIF
